function [plainBegin, cleanSegment, proportion] = CleanByEnergy5(signal, fs)
    hasCleanSegment = 0;    
    cleanSegment = [];
    proportion = 0;
    
    signalLength = length(signal);
    
    %% denoising
    % Eliminate Baseline Drift
    s2=smooth(signal,150);
    signal=signal-s2;
    % Apply Wavelet Transform
    [C,L]=wavedec(signal,8,'db4');
    [d1,d2,d3,d4,d5,d6,d7,d8]=detcoef(C,L,[1,2,3,4,5,6,7,8]);
    % Denoise 
    [thr,sorh,keepapp]=ddencmp('den','wv',signal);
    signal=wdencmp('gbl',C,L,'db4',8,thr,sorh,keepapp);

    %% remove too noisy head
    % compute energies
    windowSize = round(1.8*fs);
    paceLength = round(0.9*fs);
    signalLength = length(signal);
    energyNum = floor((signalLength - windowSize)/paceLength) + 1;
    energies = zeros(energyNum, 1);
    for i=1:length(energies)
        windowBegin = (i - 1) * paceLength + 1;
        window = signal(windowBegin : windowBegin + windowSize - 1, 1);
        energies(i,1) = (norm(window)^2)/windowSize;
    end
    % 
    plainBegin = 1;
    while energies(plainBegin) > median(energies(plainBegin:end))
        plainBegin = plainBegin + 1;
    end      
    segmentBegin = ceil((plainBegin-1)*paceLength + 1);
    signal = signal(segmentBegin:end);
    
    cleanSegment = signal;
    proportion = length(signal)/signalLength;

end