function [tmp, beatMatrix, en_thres] = extractBeats( signal, fs, beatSpan)
    beatMatrix = zeros(200, beatSpan);
    
%% Eliminate Baseline Drift
    s2=smooth(signal,150);
    signal=signal-s2;

%% Apply Wavelet Transform
    [C,L]=wavedec(signal,8,'db4');
    [d1,d2,d3,d4,d5,d6,d7,d8]=detcoef(C,L,[1,2,3,4,5,6,7,8]);
%% Denoise 
    [thr,sorh,keepapp]=ddencmp('den','wv',signal);
    signal=wdencmp('gbl',C,L,'db4',8,thr,sorh,keepapp);
    
    % detect QRS to reverse the inverted signal
%     [~,~,en_thres] = qrs_detect2(signal,0.25,0.6,fs);
    en_thres = 0;
%     if length(signal) > 1500
%         tmp1 = QRSdetected(signal, fs);
%         % if the QRS point is negtive
%         % trun the signal around the X axis
%         R_amps = signal(tmp1);
%         sign = median(R_amps);
%         if sign < 0
% %             signal = -signal;
%         end
%     end
    % detect QRS by TP algorithm
    [qrs_amp_raw,tmp,delay] = pan_tompkin(signal,fs,0);
%     [tmp,sign,en_thres] = qrs_detect2(signal,0.25,0.6,fs);
  
    % if the distance of two QRS is less than 50
    % remove the lower point
    rr = diff(tmp);
    rrLessThan50 = rr < 50;
    while ~isempty(find(rrLessThan50))
        preBeats = tmp(1:end-1);
        postBeats = tmp(2:end);
        preLower = preBeats < postBeats;
        invalidTmp1 =  preLower & rrLessThan50;
        invalidTmp1 = [invalidTmp1 0];
        postLower = ~preLower;
        invalidTmp2 = postLower & rrLessThan50;
        invalidTmp2 = [0 invalidTmp2];
        invalidTmp = invalidTmp1 | invalidTmp2;
        % remove invalid QRSs
        tmp = tmp(~invalidTmp);
        rr = diff(tmp);
        rrLessThan50 = find(rr < 50);
    end
    
    % extract each beat and add to beat matrix
    beatCount = 0;
    validBeatIndex = zeros(length(tmp),1); 
    for j=1:length(tmp)
        qrs = tmp(j);
        beatBegin = qrs - beatSpan/2;
        beatEnd = qrs + beatSpan/2 - 1;
        if beatBegin >= 1 & beatEnd<= length(signal)
            beatCount = beatCount+1;
            beat = signal(beatBegin: beatEnd)'; 
            beatMatrix(beatCount, :) = beat;
            validBeatIndex(j,1) = 1;
        end
    end
    tmp = tmp(validBeatIndex > 0);
    beatMatrix = beatMatrix(1:beatCount,:);
   
end

