function [ groups, mean_beats ] = extractMeanBeatsDBSCAN( beatMatrix, minGroupSize, minSimilarity )

if nargin<3
    [group,type]=slowdbscan_corr(beatMatrix, minGroupSize);
else
    [group,type]=slowdbscan_corr(beatMatrix, minGroupSize, 1 - minSimilarity);
end

group_ids = unique(group(type > -1));

% figure();
% plot(beatMatrix(type == -1,:)');

beatNum = size(beatMatrix,1);
groupNum = length(group_ids);
beatLen = size(beatMatrix,2);

groups = zeros(groupNum, beatNum);
mean_beats = zeros(groupNum,beatLen);
group_sizes = zeros(groupNum,1);

for i = 1:length(group_ids)
    beat_ids = (group == group_ids(i));
    groups(i,:) = beat_ids;
    mean_beats(i,:) = mean(beatMatrix(beat_ids,:));
    group_sizes(i) = sum(beat_ids);
end

% sort mean beats by groups size
[~, I] = sort(group_sizes, 'descend');
mean_beats = mean_beats(I,:);
groups = groups(I,:);

end

